// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestResponse.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__TRAITS_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__TRAITS_HPP_

#include "automotive_navigation_msgs/msg/detail/point_of_interest_response__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'point_statuses'
#include "automotive_navigation_msgs/msg/detail/point_of_interest_status__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const automotive_navigation_msgs::msg::PointOfInterestResponse & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: module_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "module_name: ";
    value_to_yaml(msg.module_name, out);
    out << "\n";
  }

  // member: request_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "request_id: ";
    value_to_yaml(msg.request_id, out);
    out << "\n";
  }

  // member: update_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "update_num: ";
    value_to_yaml(msg.update_num, out);
    out << "\n";
  }

  // member: point_statuses
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.point_statuses.size() == 0) {
      out << "point_statuses: []\n";
    } else {
      out << "point_statuses:\n";
      for (auto item : msg.point_statuses) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const automotive_navigation_msgs::msg::PointOfInterestResponse & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<automotive_navigation_msgs::msg::PointOfInterestResponse>()
{
  return "automotive_navigation_msgs::msg::PointOfInterestResponse";
}

template<>
inline const char * name<automotive_navigation_msgs::msg::PointOfInterestResponse>()
{
  return "automotive_navigation_msgs/msg/PointOfInterestResponse";
}

template<>
struct has_fixed_size<automotive_navigation_msgs::msg::PointOfInterestResponse>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<automotive_navigation_msgs::msg::PointOfInterestResponse>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<automotive_navigation_msgs::msg::PointOfInterestResponse>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__TRAITS_HPP_
